/*
Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

#include <sys/ioctl.h>
#include "dward.h"

extern int dward_fd;

int getflow(unsigned int address1, int type)
{
  struct dward d;
  d.address1 = address1;
  d.type = type;
  return ioctl(dward_fd, DIO_GETFLOW, &d);
}

int getconn(unsigned int address1, unsigned int address2,
	    unsigned short port1, unsigned short port2, int type)
{
  struct dward d;
  d.address1 = address1;
  d.port1 = port1;
  d.address2 = address2;
  d.port2 = port2;
  d.type = type;
  return ioctl(dward_fd, DIO_GETCONN, &d);
}

int resetflow(unsigned int address1)
{
  struct dward d;
  d.address1 = address1;
  return ioctl(dward_fd, DIO_RSTFLOW, &d);
}

int resetconn(unsigned int address1, unsigned int address2,
	    unsigned short port1, unsigned short port2)
{
  struct dward d;
  d.address1 = address1;
  d.port1 = port1;
  d.address2 = address2;
  d.port2 = port2;
  return ioctl(dward_fd, DIO_RSTCONN, &d);
}

int addflow(unsigned int address1, int ratelimit)
{
  struct dward d;
  d.address1 = address1;
  d.ratelimit = ratelimit;
  return ioctl(dward_fd, DIO_ADDFLOW, &d);
}

int addconn(unsigned int address1, unsigned int address2,
	    unsigned short port1, unsigned short port2, int protocol)
{
  struct dward d;
  d.address1 = address1;
  d.port1 = port1;
  d.address2 = address2;
  d.port2 = port2;
  d.protocol = protocol;
  return ioctl(dward_fd, DIO_ADDCONN, &d);
}

int delflow(unsigned int address1)
{
  struct dward d;
  d.address1 = address1;
  return ioctl(dward_fd, DIO_DELFLOW, &d);
}

int delconn(unsigned int address1, unsigned int address2,
	    unsigned short port1, unsigned short port2)
{
  struct dward d;
  d.address1 = address1;
  d.port1 = port1;
  d.address2 = address2;
  d.port2 = port2;
  return ioctl(dward_fd, DIO_DELCONN, &d);
}

int getstats(int type)
{
  struct dward d;
  d.type = type;
  return ioctl(dward_fd, DIO_GETSTAT, &d);
}
