/*Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;


/* Window class holding the DDoS panel */
public class Graph extends JFrame implements ActionListener, 
WindowListener, ComponentListener
{
  static Font sans_serif6, sans_serif8;

    static {
      sans_serif6 = new Font("SansSerif", Font.PLAIN, 6);
      sans_serif8 = new Font("SansSerif", Font.PLAIN, 8);
    }
    DDoSPanel ddos_panel;	 
    ScenFrame sf;
    JMenuBar my_menubar;
    JButton ZoomIn, ZoomOut, Start, Demo1, Demo2,Restart;
    static int maxx=0, maxy=0;
    int delay, step;
    boolean simulate=false;
    public static int start = 0;
    
    int num_victims, num_attackers, num_routers, num_ng, num_normal,
	num_dward, num_watchdog;
    JMenu file_choices;
  
    static int global_clock = 0;
    int cost = 1;

    GridBagLayout gridbag = new GridBagLayout();
    String addresses;
    String scenfile;
    
    public Graph(int port, String debugArgs[]) {
    	super("DDoS demo");
	Dimension panel_dim;
	String version;
	Toolkit toolkit = getToolkit ();
 	
    	this.getContentPane().setLayout(new BorderLayout());
	
	/* Create menubar and all menus */
    	my_menubar = new JMenuBar();
	setJMenuBar(my_menubar);
    	file_choices = new JMenu("File");
	num_victims = 0;
	num_attackers = 0;
	num_ng = 0;
	num_dward = 0;
	num_watchdog = 0;
	num_normal = 0;
	num_routers = 0;
	scenfile = new String("");
    	JMenuItem loadmenuItem = new JMenuItem("Load Topology");
    	loadmenuItem.addActionListener(this);
    	file_choices.add(loadmenuItem);
    	JMenuItem savemenuItem = new JMenuItem("Save Topology");
    	savemenuItem.addActionListener(this);
    	file_choices.add(savemenuItem);
    	JMenuItem loadscItem = new JMenuItem("Load Scenario");
	loadscItem.addActionListener(this);
    	file_choices.add(loadscItem);
    	my_menubar.add(file_choices);
	ddos_panel = new DDoSPanel(this);
	this.getContentPane().add(ddos_panel);
	
    	JPanel south = new JPanel();
    	this.getContentPane().add("South", south);
    	south.setLayout(gridbag);
    	GridBagConstraints c = new GridBagConstraints();
	
	ZoomIn = new JButton("Zoom In");
	ZoomOut = new JButton("Zoom Out");
	JLabel BlankLabel1 = new JLabel("         ");
	Start = new JButton("Start");
	JLabel BlankLabel2 = new JLabel("                                                                    ");
	Demo1 = new JButton("Demo1");
	Demo2 = new JButton("Demo2");
	Restart = new JButton("Pause");
	my_menubar.add(BlankLabel1);
	my_menubar.add(Start);
	my_menubar.add(BlankLabel2);
	my_menubar.add(Demo1);
	my_menubar.add(Demo2);
	my_menubar.add(Restart);
	c.gridwidth = 1;
	
	gridbag.setConstraints(ZoomIn,c);
	south.add(ZoomIn);
	
	gridbag.setConstraints(ZoomOut,c);
	south.add(ZoomOut);
	
	ZoomIn.addActionListener(this);
	ZoomOut.addActionListener(this);
	Start.addActionListener(this);
	Demo1.addActionListener(this);
	Demo2.addActionListener(this);
	Restart.addActionListener(this);
        addWindowListener(this);
	
        pack(); 	
    	setSize(1000,700); 
    	show();           
    } 

    /* Event handler */
    public void actionPerformed(ActionEvent evt) {
 	if (evt.getSource() instanceof JMenuItem) {
	    JMenuItem menuItem = (JMenuItem) evt.getSource();
	    String menuItemName = menuItem.getText();
	    
	    if (menuItemName.equals("Quit")) {
		System.exit(0);
	    }
	    else if (menuItemName.equals("Load Topology"))
		{
		    LoadTopology();
		}
	    else if (menuItemName.equals("Save Topology"))
		{
		    SaveTopology();
		}
	    else if (menuItemName.equals("Load Scenario"))
		{
		    LoadScenario();
		}
	}
	else if (evt.getSource() instanceof JButton) {
	    String buttonName = evt.getActionCommand();
	    if(buttonName.equals("Zoom In")) {
		ddos_panel.zoom_in(ddos_panel.getGraphics());
	    }
	    else if(buttonName.equals("Zoom Out")) {
		ddos_panel.zoom_out(ddos_panel.getGraphics());
	    }
	    else if(buttonName.equals("Start")) {
		ddos_panel.start();
		ddos_panel.startServer(addresses);
		sf.show();
		try{
		    Runtime r = Runtime.getRuntime();
		    if (!scenfile.equals(""))
			{
			    String cmd = 
				new String("sh "+scenfile+" > bashdummy &"); 
			    System.out.println(cmd);
			    r.exec(cmd);
			}
		}
		catch(Exception e)
		    {
			System.out.println("Exception "+e.toString());
		    }
	    }
	    else if(buttonName.equals("Demo1")) {
	        addresses=LoadTopology("./topologies/DEMOred.top");
		ddos_panel.update();
		this.repaint();
		LoadScenario("./scenarios/DEMOred1.scen");
		ddos_panel.start();
		ddos_panel.startServer(addresses);
		try{
		    Runtime r = Runtime.getRuntime();
		    if (!scenfile.equals(""))
			{
			    String cmd = 
				new String("sh "+scenfile+" > bashdummy &"); 
			    System.out.println(cmd);
			    r.exec(cmd);
			}
		}
		catch(Exception e)
		    {
			System.out.println("Exception "+e.toString());
		    }
	    }	
	    else if(buttonName.equals("Demo2")) {
	        addresses=LoadTopology("./topologies/DEMOred.top");
		ddos_panel.update();
		this.repaint();
		LoadScenario("./scenarios/DEMOred2.scen");
		ddos_panel.start();
		ddos_panel.startServer(addresses);
		try{
		    Runtime r = Runtime.getRuntime();
		    if (!scenfile.equals(""))
			{
			    String cmd = 
				new String("sh "+scenfile+" > bashdummy &"); 
			    System.out.println(cmd);
			    r.exec(cmd);
			}
		}
		catch(Exception e)
		    {
			System.out.println("Exception "+e.toString());
		    }
	    }
	    else if(buttonName.equals("Pause")) {
		/*
		num_victims = 0;
		num_attackers = 0;
		num_ng = 0;
		num_normal = 0;
		num_routers = 0;
		sf.hide();
		ddos_panel.restart();
		try{
		    Runtime r = Runtime.getRuntime();
		    String cmd1 = 
			new String("sh killscript > bashdummy &"); 
		    System.out.println(cmd1);
		    r.exec(cmd1);
		}
		catch(Exception e)
		    {
			System.out.println("Exception "+e.toString());
		    }
		*/
		sf.show();
		ddos_panel.sumf.show();
		ddos_panel.pause();
	    }
	}
    }
    
    /* Load topology from a file */
    private void LoadTopology() {
	  FileDialog f;	
	  f = new FileDialog(this, "Load Topology", FileDialog.LOAD);
   	  f.setDirectory("./topologies");
	  f.addComponentListener(this);
	  f.show();	              	  
	  f.hide();
	  String fdir = f.getDirectory();   
	  String filename = f.getFile();   
	  f.dispose();
	  if (fdir == null || filename == null)
	      return;
	  filename = fdir.concat(filename);
	  
	  addresses = LoadTopology(filename);
	  ddos_panel.update();
    } 
    
    /* Load scenario when given a filename */
    private void LoadScenario(String filename)
    {
	  scenfile = filename;
	  String newline;
	  try{
	      FileInputStream x = new FileInputStream(filename);
	      InputStreamReader y = new InputStreamReader(x);
	      BufferedReader input = new BufferedReader(y);
	      sf = new ScenFrame();
	      while(input.ready()) {	
		  newline = input.readLine();
		  if (newline.startsWith("#"))
		      {
			  /* Mesage that should be printed */
			  int pos = newline.indexOf(",");
			  String message = newline.substring(1,pos);
			  newline = newline.substring(pos+1);
			  pos = newline.indexOf(",");
			  int time = new Integer
			      (newline.substring(0,pos)).intValue();
			  newline = newline.substring(pos+1);
			  int duration = new Integer(newline).intValue();
			  newline = input.readLine();
			  ddos_panel.InsertMessage
			      (message,time,duration,newline);
			  sf.InsertMessage(message, time);
		      }
	      }
	      sf.setSize(300,300);
	      sf.pack();
	      sf.setLocation
		  (new Point(0,600));
	      sf.show();
	  }
	  catch (java.io.IOException e) {
	      System.out.println("FILE I/O Error");
	  }
    }

    /* Load scenario */
    private void LoadScenario() {
	
	  FileDialog f;	
	  f = new FileDialog(this, "Load Scenario", FileDialog.LOAD);
   	  f.setDirectory("./scenarios");
	  f.addComponentListener(this);
	  f.show();	             	  
	  f.hide();
	  String filename = f.getDirectory(); 	  f.dispose();
	  if (filename == null)
		  return;

	  filename = filename.concat(f.getFile());
	  if (filename == null)
	      return;
	  LoadScenario(filename);
    } 
    
    /* Load topology */
    private String LoadTopology(String filename) {
	String addresses="";
	int x_pos, y_pos, domainnum, s;
	InputStreamReader y;
	BufferedReader input;
	String version;
	String newline;
	String command_string;
	String command_args, num_string;
	int command_pos;
	int num_of_links;
	int line = 1;
	
	try {
	    FileInputStream x =  new FileInputStream(filename);
	    y = new InputStreamReader(x);
	    input = new BufferedReader(y);
	    
	    while(input.ready()) {
		newline = input.readLine();
		/* Skip comments */		
		if(newline.startsWith("#")) {
		    line++;
		    continue; 
		}
		command_pos = newline.indexOf(":");
		command_string = newline.substring(0, command_pos);
		command_args = newline.substring(command_pos+1);
		command_args = command_args.toLowerCase();
		
		if(command_string.equals("nodes")) {
		    int maxNode =LoadNodes(command_args);
		} 
		else if(command_string.startsWith("router") ||
			command_string.equals("victim") || 
			command_string.equals("ng") ||
			command_string.equals("attacker") || 
			command_string.equals("client") ||
			command_string.equals("watchdog") ||
			command_string.equals("dward"))
		    {
			addresses+= 
			    LoadNode(command_string,command_args,
				     ddos_panel.itemCount);
			ddos_panel.itemCount++;
		    } else if(command_string.equals("numlinks")) {
			num_string = command_args.trim();
			num_of_links = (new Integer(num_string)).intValue();
		    } else if(command_string.equals("link")) {
			LoadLink(command_args);
		    }  else if(command_string.equals("sniff")) {
			LoadSniff(command_args);
		    } 
		line++;
	    }
	    x.close();
	}
	catch (java.io.IOException e) {
	    System.out.println("FILE I/O Error");
	}
	return addresses;
    } 	
    
    /* Save topology to a file */
    private void SaveTopology() {
	String line;
	FileDialog f;
	f = new FileDialog(this, "Save Topology", FileDialog.SAVE);
	f.setDirectory("./topologies");
	f.show();     
	try {
	    String filename = f.getDirectory();   
	    if (filename == null) 
		return;
	    filename = filename.concat(f.getFile());
	    
	    FileOutputStream x = new FileOutputStream(filename);
	    PrintWriter output = new PrintWriter(x);
	    
	    /* Total Number of nodes */
	    line = "nodes: " + ddos_panel.nnodes;
	    output.println(line);
	    
	    /* Node Type and Node Number */
	    for (int i = 0; i < ddos_panel.nnodes; i++) {
		output.println(ddos_panel.nodes[i].type
			       +":"+(int)ddos_panel.nodes[i].x+","
			       +(int)ddos_panel.nodes[i].y+","
			       +ddos_panel.nodes[i].lbl);
	    }
	    
	    /* Write the edges */
	    output.println("numlinks:" + ddos_panel.nedges);
	    for (int i = 0; i < ddos_panel.nedges; i++) {
		line = "link:";
		line += (int)ddos_panel.edges[i].from;
		line += ",";
		line += (int)ddos_panel.edges[i].to;
		output.println(line);   
	    } 	 
	    output.flush();
	    output.close();
	    x.close();
	}
	catch (java.io.IOException e) {
	    System.out.println("FILE write Error");
	}
    }

    /* Load number of nodes from file */
    private int LoadNodes(String command_args) {
	int nonodes;
	String node_string;
	node_string = command_args.trim();
	nonodes = (new Integer(node_string)).intValue();
	return nonodes;
    }
    
    /* Load a node from a file */
    private String LoadNode(String type, String command_args, int cur_node) {
	String rest, domain, x_poss, y_poss, domain_type;
	int interfaces, x_pos, y_pos, spos;

	spos = command_args.indexOf(",");

	x_poss = command_args.substring(0, spos);
	x_pos = (new Integer(x_poss)).intValue();
	rest = command_args.substring(spos+1);
	
	spos = rest.indexOf(",");
	y_poss = rest.substring(0,spos);
	y_pos = (new Integer(y_poss)).intValue();
	rest = rest.substring(spos+1);
	
	if (x_pos>maxx) maxx=x_pos;
	if (y_pos>maxy) maxy=y_pos;
	IPAddress add = new IPAddress(rest);
	int num = 0;
	if (type.equals("victim"))
	    {
		num=++num_victims;
	    }	
	else if (type.equals("ng"))
	    {
		num=++num_ng;
	    }	
	else if (type.startsWith("router"))
	    {
		num=++num_routers;
	    }	
	else if (type.startsWith("watchdog"))
	    {
		num=++num_watchdog;
	    }	
	else if (type.startsWith("dward"))
	    {
		num=++num_dward;
	    }	
	else if (type.equals("client"))
	    {
		num=++num_normal;
	    }	
	else if (type.equals("attacker"))
	{
		num = ++num_attackers;
	}	
	ddos_panel.addNode(add, x_pos, y_pos, type, num);
	if(type.equals("victim"))
	    return add.toString()+",";
	else
	    return "";
    }

    /* Load one edge */
    private void LoadLink(String command_args) {
	String froms, tos, bws, delays, sizes, rest, quetype_string,
	    minthres_string, maxthres_string, ques, pques;
	int from, to, fint, tint, bw, delay, len, spos, start, type_end;
	int red, min_thres, max_thres, quesize, pquesize;
	
	/* From node */
	spos = command_args.indexOf(",");
	froms = command_args.substring(0, spos);
	from = (new Integer(froms)).intValue();
	rest = command_args.substring(spos+1);

	/* To node */
	to = (new Integer(rest)).intValue();
	System.out.println("From "+from+" to "+to);
	ddos_panel.addEdge
	    (ddos_panel.FindNode(from),ddos_panel.FindNode(to));
    }

    private void LoadSniff(String command_args) {
	String froms, tos, bws, delays, sizes, rest, quetype_string,
	    minthres_string, maxthres_string, ques, pques;
	int from, to, fint, tint, bw, delay, len, spos, start, type_end;
	int red, min_thres, max_thres, quesize, pquesize;
	
	/* From link */
	spos = command_args.indexOf(",");
	froms = command_args.substring(0, spos);
	from = (new Integer(froms)).intValue();
	rest = command_args.substring(spos+1);

	/* To link */
	to = (new Integer(rest)).intValue();
	System.out.println("From "+from+" to "+to);
	ddos_panel.addSniff(from,to);
    }


    /* If window is closed exit the program */
    public void windowClosed(WindowEvent e)
    {
	System.exit(0);
    }

    public void windowIconified(WindowEvent e)
    {
  	ddos_panel.changed=true;
    }

    public void windowActivated(WindowEvent e)
    {
  	ddos_panel.changed=true;
    }
    
    public void windowClosing(WindowEvent e)
    {
	System.exit(0);
    }
    
    public void windowDeactivated(WindowEvent e)
    {
  	ddos_panel.changed=true;
    }
    
    public void windowDeiconified(WindowEvent e)
    {
  	ddos_panel.changed=true;
    }
    
    public void windowOpened(WindowEvent e)
    {
  	ddos_panel.changed=true;
    }
    
    public void componentHidden(ComponentEvent e)
    {
  	ddos_panel.changed=true;
    }
    
    public void componentShown(ComponentEvent e)
    {
	ddos_panel.changed=true;
    }
    
    public void componentMoved(ComponentEvent e)
    {
  	ddos_panel.changed=true;
    }
    
    public void componentResized(ComponentEvent e)
    {
	ddos_panel.changed=true;
    }
}
