/*Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;
import java.io.*;

public class TrackingFrame extends JFrame 
    implements ActionListener, WindowListener, 
	       ComponentListener, MouseListener
{
    TrackPanel panel;

    public TrackingFrame(Node n) {
    	super("Tracking window "+n.type+" "+n.ID);
    	this.getContentPane().setLayout(new BorderLayout());
    	JMenuBar my_menubar = new JMenuBar();
	setJMenuBar(my_menubar);
	panel = new TrackPanel(n);
	panel.setBackground(Color.white);
	this.getContentPane().add("Center",panel);
	panel.addMouseListener(this);
    } 
    
    public void repaint()
    {	
	panel.changed = true;
    }

    public void mousePressed(MouseEvent event)
    {
	int x = event.getX();
	int y = event.getY();
	panel.showValues(x,y);    
    }
    
    public void mouseClicked(MouseEvent event)
    {
    }
    
    public void mouseReleased(MouseEvent event)
    {
	panel.hideValues();    
    }
    
    public void mouseEntered(MouseEvent event)
    {
    }
    
    public void mouseExited(MouseEvent event)
    {
    }
    
    public void actionPerformed(ActionEvent evt) 
    {
    }
    
    
    public void windowClosed(WindowEvent e)
    {
	panel.isVisible = false;
	panel.active = false;
    }
    
    public void windowIconified(WindowEvent e)
    {
    }
    
    public void windowActivated(WindowEvent e)
    {
    }
    
    public void windowClosing(WindowEvent e)
    {
	panel.isVisible = false;
	panel.active = false;
    }
    
    public void windowDeactivated(WindowEvent e)
    {
    }
    
    public void windowDeiconified(WindowEvent e)
    {
    }
    
    public void windowOpened(WindowEvent e)
    {
    }
    
    public void componentHidden(ComponentEvent e)
    {
    }
    
    public void componentShown(ComponentEvent e)
    {
    }
    
    public void componentMoved(ComponentEvent e)
    {
    }
    
    public void componentResized(ComponentEvent e)
    {
    }
} 
