/*Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

#ifndef __DWARD_H
#define __DWARD_H

/* Function prototypes from rl_deamon.c */
int getflow(unsigned int,int);
int getconn(unsigned int, unsigned int,
	    unsigned short, unsigned short,int);
int resetflow(unsigned int);
int resetconn(unsigned int, unsigned int,
	      unsigned short, unsigned short);
int addflow(unsigned int, int);
int delflow(unsigned int);
int addconn(unsigned int, unsigned int,
	    unsigned short, unsigned short, int);
int delconn(unsigned int, unsigned int,
	    unsigned short, unsigned short);
int getstats(int);

#define	DIO_GETFLOW	0
#define	DIO_GETCONN	1
#define	DIO_RSTFLOW	2
#define	DIO_RSTCONN	3
#define	DIO_ADDFLOW	4
#define	DIO_DELFLOW	5
#define	DIO_ADDCONN	6
#define	DIO_DELCONN	7
#define	DIO_GETSTAT	8

struct dward {
	unsigned int address1;
	unsigned int address2;
	int type;
	int protocol;
	int ratelimit;
	unsigned short port1;
	unsigned short port2;
};

/* Major device number */
#define DWARD_MAJOR 146

#endif
