/* Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.*/

#include <linux/types.h>
#include <linux/time.h>
#include <linux/config.h>  
#include <linux/slab.h> 
#include <linux/vmalloc.h> 
#include <linux/mm.h> 
#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/types.h> 
#include <linux/stddef.h> 
#include <linux/types.h> 
#include <linux/netfilter.h> 
#include <linux/netfilter_ipv4.h> 
#include <linux/skbuff.h> 
#include <linux/in.h> 
#include <linux/ip.h> 
#include <linux/tcp.h> 
#include <linux/udp.h> 
#include <linux/icmp.h> 
#include <linux/netdevice.h> 
#include <linux/if_ether.h> 
#include <sys/syscall.h>  
#include <linux/sched.h>
#include <linux/timer.h>
#include <linux/types.h> 
#include <linux/netfilter.h> 
#include <linux/netfilter_ipv4.h> 
#include <linux/skbuff.h>
#include <linux/unistd.h>
#include <asm/semaphore.h>
#include <endian.h>
#include <unistd.h>
#include <linux/devfs_fs_kernel.h>
#include <linux/errno.h>
#include <linux/fs.h>
#include <asm/uaccess.h>

#include "sniff.h"

static ssize_t sniff_write(struct file * file, const char * buf,
			   size_t count, loff_t *ppos)
{
  return(-EIO);
}

static ssize_t sniff_read(struct file * file, char * buf,
			  size_t count, loff_t *ppos)
{
  return(-EIO);
}

static int sniff_open(struct inode * inode, struct file * file)
{
  return(0);
}

static int sniff_release(struct inode * inode, struct file * file)
{
  return(0);
}

static int sniff_ioctl(struct inode *inode, struct file *file,
		       unsigned int cmd, unsigned long arg)
{
  struct sniff parms;
  
  if (copy_from_user(&parms, (struct sniff *)arg, sizeof(struct sniff)))
    return(-EFAULT);
  return read_buffer(parms.buffer, parms.plen, parms.packet_count);
}

static struct file_operations sniff_fops = {
	owner:		THIS_MODULE,
	write:		sniff_write,
	ioctl:		sniff_ioctl,
	open:		sniff_open,
	release:	sniff_release,
	read:		sniff_read,
};



