/* Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
 */

#include <string.h>
#include <stdio.h>
#include <time.h>
#include "functions.h"

char* months[12]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

/* Get human readable time from UTC notation */
void gettime(unsigned int t, char* times)
{
  const time_t t = time(0);
  strcpy(times,ctime(&t));
  times[strlen(times)-1]=0;
}

/* Does the string contain a number */
int isNumber(char* num)
{
  int i;
  for(i=0;i<strlen(num);i++)
    if (!isdigit(num[i]))
      return 0;
  return 1;
}

/* Check if string contains IP address.port */ 
int isIPAddress(char* c)
{
	int i, dots = 0;
	for (i=0;i<strlen(c);i++)
	{
	  if (c[i] == '.') 
	    dots++;
	  else if (c[i] == ':')
	    break;
	  else if (!isdigit(c[i]) && dots<4)
	    {
	      return 0;
	    }
	}
	if (dots == 4 || dots == 3) 
	  return 1;
	else
	  return 0;
}

/* Return one word from string */
void get_word(char* c, int* count, char* t)
{
	int j, i = *count;
	for(j=0;i<strlen(c) && !isspace(c[i]);t[j++]=c[i++]);	
	t[j]=0;
	*count = i;
}

/* Take out one word from string */
void eat_word(char* c, int* count)
{
	int i = *count;
	for(;i<strlen(c) && !isspace(c[i]);i++);	
	*count = i;
}

/* Take out spaces from string up to next word */
void eat_space(char* c, int* count)
{
	int i = *count;
	for(;i<strlen(c) && isspace(c[i]);i++);	
	*count = i;
}

/* Take out spaces from string */
void trim(char* c)
{
	int i = 0, j;
	for(j=0;j<strlen(c);j++)
	  if(!isspace(c[j]))
	    c[i++]=c[j];
	c[i]=0;
}










